package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_2_2_Raycast extends ActorScript
{
	public var _XOrigin:Float;
	public var _YOrigin:Float;
	public var _XTarget:Float;
	public var _YTarget:Float;
	public var _RaycastOriginbyAnimation:Array<Dynamic>;
	public var _RaycastList:Array<Dynamic>;
	public var _Debug:Bool;
	
	/* ========================= Custom Block ========================= */
	public function _customBlock_Raycasting(__XTarget:Float, __YTarget:Float):Array<Dynamic>
	{
		var __Self:Actor = actor;
		_XTarget = __XTarget;
		_YTarget = __YTarget;
		_RaycastList = new Array<Dynamic>();
		Utils.clear(_RaycastList);
		/* Set Origin */
		_XOrigin = actor.getXCenter();
		_YOrigin = actor.getYCenter();
		for(item in cast(_RaycastOriginbyAnimation, Array<Dynamic>))
		{
			if((actor.getAnimation() == ("" + item).split(",")[0]))
			{
				_XOrigin = (actor.getX() + asNumber(("" + item).split(",")[1]));
				_YOrigin = (actor.getY() + asNumber(("" + item).split(",")[2]));
			}
		}
		/* Detect Tiles */
		for(index0 in 0...Std.int((Math.max(Math.abs((_YTarget - _YOrigin)), Math.abs((_XTarget - _XOrigin))) / getTileWidth())))
		{
			if((Math.abs((_YTarget - _YOrigin)) > Math.abs((_XTarget - _XOrigin))))
			{
				if(tileCollisionAt(getTilePosition(1,(Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0))),getTilePosition(0,((((_XTarget - _XOrigin) / (_YTarget - _YOrigin)) * ((Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0)) - _YOrigin)) + _XOrigin)),0,"-1"))
				{
					_RaycastList.push((("" + ((((_XTarget - _XOrigin) / (_YTarget - _YOrigin)) * ((Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0)) - _YOrigin)) + _XOrigin)) + (((",") + ("" + (Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0)))))));
				}
			}
			else
			{
				if(tileCollisionAt(getTilePosition(1,((((_YTarget - _YOrigin) / (_XTarget - _XOrigin)) * ((Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0)) - _XOrigin)) + _YOrigin)),getTilePosition(0,(Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0))),0,"-1"))
				{
					_RaycastList.push((("" + (Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0))) + (((",") + ("" + ((((_YTarget - _YOrigin) / (_XTarget - _XOrigin)) * ((Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0)) - _XOrigin)) + _YOrigin))))));
				}
			}
		}
		return _RaycastList;
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("X Origin", "_XOrigin");
		_XOrigin = 0.0;
		nameMap.set("Y Origin", "_YOrigin");
		_YOrigin = 0.0;
		nameMap.set("X Target", "_XTarget");
		_XTarget = 0.0;
		nameMap.set("Y Target", "_YTarget");
		_YTarget = 0.0;
		nameMap.set("Raycast Origin by Animation", "_RaycastOriginbyAnimation");
		nameMap.set("Raycast List", "_RaycastList");
		nameMap.set("Debug", "_Debug");
		_Debug = false;
		
	}
	
	override public function init()
	{
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(_Debug)
				{
					g.translateToScreen();
					g.strokeColor = Utils.getColorRGB(0,0,0);
					g.strokeSize = 1;
					g.drawLine(_XOrigin, _YOrigin, _XTarget, _YTarget);
					g.drawString("" + (("Number of Checks: ") + ("" + Math.floor((Math.max(Math.abs((_YTarget - _YOrigin)), Math.abs((_XTarget - _XOrigin))) / getTileWidth())))), 20, 20);
					g.drawString("" + (("Origin: ") + ((("" + _XOrigin) + (((",") + ("" + _YOrigin)))))), 20, 40);
					g.drawString("" + (("Target: ") + ((("" + _XTarget) + (((",") + ("" + _YTarget)))))), 20, 60);
					for(index0 in 0...Std.int((Math.max(Math.abs((_YTarget - _YOrigin)), Math.abs((_XTarget - _XOrigin))) / getTileWidth())))
					{
						g.fillColor = Utils.getColorRGB(255,200,0);
						if((Math.abs((_YTarget - _YOrigin)) > Math.abs((_XTarget - _XOrigin))))
						{
							if(tileCollisionAt(getTilePosition(1,(Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0))),getTilePosition(0,((((_XTarget - _XOrigin) / (_YTarget - _YOrigin)) * ((Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0)) - _YOrigin)) + _XOrigin)),0,"-1"))
							{
								g.fillColor = Utils.getColorRGB(255,0,0);
							}
							g.fillCircle(((((_XTarget - _XOrigin) / (_YTarget - _YOrigin)) * ((Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0)) - _YOrigin)) + _XOrigin), (Math.min(_YOrigin, _YTarget) + (getTileHeight() * index0)), 3);
						}
						else
						{
							if(tileCollisionAt(getTilePosition(1,((((_YTarget - _YOrigin) / (_XTarget - _XOrigin)) * ((Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0)) - _XOrigin)) + _YOrigin)),getTilePosition(0,(Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0))),0,"-1"))
							{
								g.fillColor = Utils.getColorRGB(255,0,0);
							}
							g.fillCircle((Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0)), ((((_YTarget - _YOrigin) / (_XTarget - _XOrigin)) * ((Math.min(_XOrigin, _XTarget) + (getTileWidth() * index0)) - _XOrigin)) + _YOrigin), 3);
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}